<?php
/**
 * tableBB 1.0
 * Copyright © 2009 Dilma & iarspider
 * Copyright © 2008 MyBB Group, All Rights Reserved
 * This file is a part of Full Russian MyBB Translation, version 2.4 / 30.11.08 / done by Alex007
 * Website: http://table.com
 * License: http://www.mybboard.net/about/license
 *
 */

// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB"))
{
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

require_once ("inc/functions.php");

$plugins->add_hook("datahandler_post_update", "code2attach_datahandler_post_update");
$plugins->add_hook("datahandler_post_insert_post", "code2attach_datahandler_post_insert_post");
$plugins->add_hook("datahandler_post_insert_thread_post", "code2attach_datahandler_post_insert_thread_post");


function code2attach_info()
{
	global $lang;
	$lang->load("code2attach", false, true);

	/**
	 * Array of information about the plugin.
	 * name: The name of the plugin
	 * description: Description of what the plugin does
	 * website: The website the plugin is maintained at (Optional)
	 * author: The name of the author of the plugin
	 * authorsite: The URL to the website of the author (Optional)
	 * version: The version number of the plugin
	 * guid: Unique ID issued by the MyBB Mods site for version checking
	 * compatibility: A CSV list of MyBB versions supported. Ex, "121,123", "12*". Wildcards supported.
	 */
	return array(
		"name"			=> "Long Code To Attachment",
		"description"	=> $lang->ca_plugin_desc,
		"website"		=> "http://www.hiasm.com",
		"author"		=> "iarspider (parts of code courtesy of Dilma)",
		"authorsite"	=> "http://www.hiasm.com",
		"version"		=> "1.0",
		"guid" 			=> "",
		"compatibility" => "*"
	);
}

function code2attach_activate()
{
	global $db, $lang;

	$settings_gid = $db->insert_query('settinggroups', array(
		'name' => 'code2attach',
		'title' => $lang->ca_settings,
		'disporder' => 50,
	));

	$db->insert_query('settings', array(
		'name' => 'code2attach_enable',
		'optionscode' => 'yesno',
		'value' => 1,
		'title' => $lang->ca_settings_enable,
		'description' => $lang->ca_settings_enable_desc,
		'disporder' => 1,
		'gid' => $settings_gid
	));

	$db->insert_query('settings', array(
		'name' => 'code2attach_maxlength',
		'optionscode' => 'text',
		'value' => 100,
		'title' => $lang->ca_settings_maxlen,
		'description' => $lang->ca_settings_maxlen_desc,
		'disporder' => 2,
		'gid' => $settings_gid
	));

	rebuildsettings();
}

function code2attach_deactivate()
{
	global $db;

	$db->delete_query("settings", "name IN('code2attach_enable', 'code2attach_maxlength')");
	$db->delete_query("settinggroups", "name = 'code2attach'");

	rebuildsettings();
}

function code2attach_reg_callback($matches)
{
	global $mybb, $db, $code2attach_posthash, $pid;

	$maxlen = $mybb->settings['code2attach_maxlength'];

	$code_block = $matches[1];
	$code_len = strlen($code_block);
	if($code_len > $maxlen)
	{
		$q = $db->query("SELECT aid FROM ".TABLE_PREFIX."attachments ORDER BY aid DESC LIMIT 1");
		$aid = $db->fetch_field($q, 'aid');
		if (!isset($aid))
			$aid = 0;

		$code_file = fopen("./uploads/code_".$aid.".txt", "w+");
		fwrite($code_file, $code_block);
		fclose($code_file);
		$code_filename = "code_".$aid.".txt";

		$aid = $db->insert_query('attachments', array(
			'aid' => 'NULL',
			'pid' => $pid,
			'posthash' => $code2attach_posthash,
			'filename' => $code_filename,
			'filetype' => 'text/plain',
			'filesize' => $code_len,
			'attachname' => $code_filename,
			'dateuploaded' => time(),
			'visible' => '1',
			'thumbnail' => 'SMALL'
			)
		);

		return("[attachment=".$aid."]");
	}
	else
	{
		return("[code]".$code_block."[/code]");
	}
}

function code2attach_datahandler_post_update($it)
{
	global $mybb, $db;
	global $code2attach_posthash, $pid;

	if ($mybb->settings['code2attach_enable'] == '1')
	{
		$pid = $it->pid;
		$tid = $it->tid;
		$queryhash = $db->simple_select('posts', 'posthash', "pid = '".$pid."'");
		$code2attach_posthash = $db->fetch_field($queryhash, 'posthash');

		$it->post_update_data['message'] = preg_replace_callback("#\[code\](.*?)\[/code\]#si", "code2attach_reg_callback", $it->post_update_data['message']);
	}
}

function code2attach_datahandler_post_insert_post($it)
{
	global $mybb;
	global $code2attach_posthash;

	if ($mybb->settings['code2attach_enable'] == '1')
	{
		$code2attach_posthash = $it->post_update_data['posthash'];
		$it->post_update_data['message'] = preg_replace_callback("#\[code\](.*?)\[/code\]#si", "code2attach_reg_callback", $it->post_update_data['message']);

		$code2attach_posthash = $it->post_insert_data['posthash'];
		$it->post_insert_data['message'] = preg_replace_callback("#\[code\](.*?)\[/code\]#si", "code2attach_reg_callback", $it->post_insert_data['message']);
	}
}

function code2attach_datahandler_post_insert_thread_post($it)
{
	global $mybb;
	global $code2attach_posthash;

	if ($mybb->settings['code2attach_enable'] == '1')
	{
 		$code2attach_posthash = $it->post_insert_data['posthash'];
 		$it->post_insert_data['message'] = preg_replace_callback("#\[code\](.*?)\[/code\]#si", "code2attach_reg_callback", $it->post_insert_data['message']);
	}
}

?>
